/*******************************************************************************
 * Copyright (c) 2010, Jean-David Gadina - www.xs-labs.com
 * Distributed under the Boost Software License, Version 1.0.
 * 
 * Boost Software License - Version 1.0 - August 17th, 2003
 * 
 * Permission is hereby granted, free of charge, to any person or organization
 * obtaining a copy of the software and accompanying documentation covered by
 * this license (the "Software") to use, reproduce, display, distribute,
 * execute, and transmit the Software, and to prepare derivative works of the
 * Software, and to permit third-parties to whom the Software is furnished to
 * do so, all subject to the following:
 * 
 * The copyright notices in the Software and this entire statement, including
 * the above license grant, this restriction and the following disclaimer,
 * must be included in all copies of the Software, in whole or in part, and
 * all derivative works of the Software, unless such copies or derivative
 * works are solely in the form of machine-executable object code generated by
 * a source language processor.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
 * SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
 * FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 ******************************************************************************/

/* $Id$ */

#import "ApplicationDelegate.h"
#import "ListViewController.h"
#import "ASLHelper.h"

@implementation ApplicationDelegate

@synthesize window = _window;

- ( void )dealloc
{
    [ _listController       release ];
    [ _navigationController release ];
    [ _window               release ];
    
    [ super dealloc ];
}

- ( BOOL )application: ( UIApplication * )application didFinishLaunchingWithOptions: ( NSDictionary * )launchOptions
{
    ( void )application;
    ( void )launchOptions;
    
    [ ASLHelper sharedInstance ];
    
    _listController            = [ ListViewController new ];
    _navigationController      = [ [ UINavigationController alloc ] initWithRootViewController: _listController ];
    _window                    = [ [ UIWindow alloc ] initWithFrame: [ [ UIScreen mainScreen ] bounds ] ];
    _window.rootViewController = _navigationController;
    
    _navigationController.navigationBar.tintColor = [ UIColor colorWithHue: ( CGFloat )0.59 saturation: ( CGFloat )0.1 brightness: ( CGFloat )0.65 alpha: ( CGFloat )1 ];
    
    [ self.window makeKeyAndVisible ];
    
    return YES;
}

@end
